package me.totalfreedom.discord.command;

import discord4j.core.event.domain.interaction.ChatInputInteractionEvent;
import discord4j.core.spec.EmbedCreateSpec;
import discord4j.rest.util.Color;
import me.totalfreedom.discord.handling.SlashCommand;
import me.totalfreedom.totalfreedommod.util.FUtil;
import org.bukkit.Bukkit;
import org.jetbrains.annotations.NotNull;
import reactor.core.publisher.Mono;

public class TPSCommand implements SlashCommand
{
    @Override
    public String getName()
    {
        return "tps";
    }

    @Override
    public Mono<Void> handle(@NotNull ChatInputInteractionEvent event)
    {
        String tps = String.valueOf(FUtil.getMeanAverageDouble(Bukkit.getServer().getTPS()));

        EmbedCreateSpec spec = EmbedCreateSpec.builder()
                .title("Current Server Tick Information")
                .addField("TPS", tps, false)
                .addField("Uptime", FUtil.getUptime(), false)
                .addField("Maximum Memory", Math.ceil(FUtil.getMaxMem()) + " MB", false)
                .addField("Allocated Memory", Math.ceil(FUtil.getTotalMem()) + " MB", false)
                .addField("Free Memory", Math.ceil(FUtil.getFreeMem()) + " MB", false)
                .color(Color.BISMARK)
                .build();

        return event.reply()
                .withEmbeds(spec)
                .withEphemeral(true);
    }
}
